#!/bin/bash
# Copyright 2009, 2014, 2015 Michal Žejdl
# pro trojici local port remote vrátí port na remote, kam je přímo připojen local
# nebo nevrátí nic
# pracuje s tabulkou freshfdb (seříznutá fdb) 

confdir=$(dirname $0)/../core
config=$confdir/defaults.sh
test -f $config || exit
. $config

if test "$#" -ne 3; then
  echo "čekám tři parametry - local port remote" >&2
  echo "například: $0 sw4924-inf 10 sw4250-inf" >&2
  exit
fi

local=$1
port=$2
remote=$3

# nejdříve vybereme na přepínači "remote" port, na kterém by měl být připojen přepínač "local"
# tedy takový port, na kterém jsou mac adresy naučené na přepínači "local"
# na jiném portu, než je protější "port"

# nejdříve zjistíme počet vyhovujících portů - víc než jeden nebo žádný je špatně

pocet=$(mysql -e "select count(distinct port) from freshfdb where switch = '$remote' and mac in (select mac from freshfdb where switch = '$local' and port != $port)" $modify_opts -s)

if test $pocet -ne 1; then
  echo "u trojice $local $port $remote jsem našel nevyhovující počet remote portů ($pocet)" >&2
  exit
fi

# tak teď máme žhavého kandidáta

remoteport=$(mysql -e "select distinct port from freshfdb where switch = '$remote' and mac in (select mac from freshfdb where switch = '$local' and port != $port)" $modify_opts -s)

# jednoduchá kontrola, jestli jsou sousedé - na styčných portech nesmí být stejné MAC adresy
# počítám s tím, že záznamy typu switch 1 switch (viz třeba Compex) byly eliminovány
# při vytváření freshfdb

pocet=$(mysql -e "select count(*) from freshfdb where switch = '$remote' and port = '$remoteport' and mac in (select mac from freshfdb where switch = '$local' and port = $port)" $modify_opts -s)

# testuju, protože ./remoteport.sh ap5-jehlicna 31 sw4200-ssedlo dává 24 (nejsou tam ta ap-naučena)

#pocet=$(mysql -e "select count(*) from freshfdb where switch = '$local' and port = '$port' and mac in (select mac from freshfdb where switch = '$remote' and port = $remoteport)" $modify_opts -s)

# finále

if test $pocet -ne 0; then
  echo "$local a $remote nejsou sousedé (průnik z remote na local je $pocet)" >&2 
  exit
fi

echo $remoteport
