#!/bin/bash
# Michal Žejdl 2010
# hledá řetězec v IPv6
# kopie skriptu arp.sh s drobnými úpravami

. /usr/local/etc/mysql_prepinace

if test "$#" -ne "1"; then
  echo -e "\nJako parametr čekám část MAC adresy, IPv6 adresu nebo DNS jméno."
  echo "Je možné použít zástupný znak %."
  echo -e "\nnapříklad:\n"
  echo "  arp.sh 12:12"
  echo -e "  arp.sh %-inf-%\n"
  exit
fi

vstup=$1
mac=$(echo $vstup | arpwatch2normal)
# převedeme na dlouhou, jak je uložena v db
ip6=$(ipv6calc -I ipv6addr -O ipv6addr -F $vstup 2> /dev/null)

mysql -e "select mac, ip6, dns, from_unixtime(time) time from nd left join checked using (mac) where mac like '%$mac%' or ip6 like '$ip6' or dns like '$vstup' order by time" $mysql_prepinace
