<?php

/*
 * Copyright 2013 - 2018 Michal Žejdl
 */

$document_root = ".";

require "$document_root/init.php";

$title = gettext("DNS name");

page_open($document_root, $title);



if (!isset($_GET["id"]))
	exit("<p>" . gettext("the id argument is missing"));

$dns = $_GET["id"];
  
if (!preg_match("/^[a-zA-Z0-9.-]+$/", $dns)) {
	echo "<p>";
	echo gettext("the id argument doesn't match the expected pattern");
	echo "\n";
	return;
}

echo "<h1>$title $dns</h1>\n";

// TXT was added in PHP 5.2.4
//if (checkdnsrr($dns, "TXT")) {
if (dns_get_record($dns, DNS_TXT)) {
	echo "<p>\n";
	echo gettext("this name was automatically registered via DDNS");
}

if (checkdnsrr($dns, "A")) {
	echo "<h2>", gettext("IPv4 addresses"), "</h2>\n";
	echo "<ul>\n";
	$records = dns_get_record($dns, DNS_A);
	foreach ($records as $record) {
		echo "<li>";
		echo "<a href=\"ipv4.php?id=$record[ip]\">$record[ip]</a>\n";
	}
	echo "</ul>\n";
}

if (checkdnsrr($dns, "AAAA")) {
	echo "<h2>", gettext("IPv6 addresses"), "</h2>\n";
	echo "<ul>\n";
	$records = dns_get_record($dns, DNS_AAAA);
	foreach ($records as $record) {
		echo "<li>";
		echo "<a href=\"ipv6.php?id=";
		echo expand_ipv6($record["ipv6"]);
		echo "\">";
		// ugly, but dns_get_record() returned me x:x::x:0:0:x:x
		echo ipv6_compress(expand_ipv6($record["ipv6"]));
		echo "</a>\n";
	}
	echo "</ul>\n";
}


print_url_block($dns);


page_close($document_root);

?>
