<?php

/*
 * Copyright 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = "Alcoma alMP MIB";

page_open($document_root, $title);


// enable debug_print()
//$debug = true;

// init db
$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit;
mysql_select_db($dbname);

if (isset($_GET["agent"])) {
	$snmpagentid = $_GET["agent"];
	// validity check
	if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;

	// start is not required
	if (isset($_GET["start"]) 
			and preg_match("/^[[:alnum:]-]+$/", $_GET["start"]))
		$start = $_GET["start"];
	// PHP automagicaly initializes variables from URL
	else unset($start);
	
	// end is not required
	if (isset($_GET["end"])
			and preg_match('/^[[:alnum:]-]+$/', $_GET["end"]))
		$end = $_GET["end"];
	else unset($end);

	print_snmp_header($document_root, $snmpagentid);

	echo "<h2>$title</h2>\n";

	// common variables for RRD graphs
	$thisdir = dirname(__FILE__);
	$bindir = $thisdir . "/../../bin";
	$outputdir = "imgcache/" . $snmpagentid;
	if (!is_dir($outputdir))
		if (!mkdir($outputdir, 0777, true))
			exit("<p>mkdir($outputdir) failed");

	if (isset($start)) $starts = array($start);
	else $starts = array("now-1d", "now-1w", "now-1m", "now-1y");

	if (!isset($end)) $end = "now";

	$mibnodes = array("alMPODU", "alMPModem", "alMPLine2", "alMPLine3",
			"alMPLine4");

	foreach ($mibnodes as $mibnode) {

		$rrdfile = "snmpagent/" . $snmpagentid .
			"/Alcoma/" . $mibnode . ".rrd";

		if (!file_exists($rrdbasedir . "/" . $rrdfile)) continue;

		echo "<h3>$mibnode</h3>\n";
		echo "<p class=\"center\">\n";

		switch ($mibnode) {
			case "alMPODU":
				$datasources = array("RXLevel", "Temperature");
				break;
			case "alMPModem":
				$datasources = array("Quality", "SNR");
				break;
			case "alMPLine2":
			case "alMPLine3":
			case "alMPLine4":
				$datasources = array("Byte", "Pkt");
				break;
		}

		foreach ($starts as $start) {
			$command = "$bindir/graph-alcoma.sh"
				. " $rrdbasedir $rrdfile"
				. " $thisdir/$outputdir $start $end";
			if (! empty($rrdcached))
				$command .= " $rrdcached";
			debug_print($command);
			exec($command);

			foreach ($datasources as $datasource) {

				echo "<img alt=\"$datasource\"",
				     " src=\"$outputdir/alcoma",
				     "-$mibnode-$datasource",
				     "-$start-$end.png\">";
			}
			echo "<br>\n";
		}
	}
}



page_close($document_root);

?>
